require 'spec_helper'

describe RocketGate::Configuration do
  describe '#initialize' do
    let(:config) { RocketGate::Configuration.new }

    it 'supplies a reasonable default config' do
      expect(config.currency).to eq RocketGate::Configuration::DEFAULT_CURRENCY
      expect(config.request_host).to eq RocketGate::Configuration::GATEWAY_LIVE_HOST
      expect(config.request_path).to eq RocketGate::Configuration::GATEWAY_SERVLET
      expect(config.request_port).to eq RocketGate::Configuration::GATEWAY_PORT
      expect(config.request_timeout).to eq RocketGate::Configuration::DEFAULT_TIMEOUT
      expect(config.request_version).to eq RocketGate::Configuration::GATEWAY_VERSION
      expect(config.require_avs).to eq true
      expect(config.require_cvv).to eq true
      expect(config.require_scrub).to eq true
      expect(config.require_ssl).to eq true
    end
  end

  describe '#testing!' do
    subject { config.testing! }

    let(:config) { RocketGate::Configuration.new }

    it 'sets up the default testing configuration' do
      expect(subject).to eq config
      expect(config.request_host).to eq RocketGate::Configuration::GATEWAY_TEST_HOST
      expect(config.merchant_id).to eq '1'
      expect(config.merchant_password).to eq 'testpassword'
    end
  end
end
